#include <stdio.h>
#include "cv.h"
#include "cxcore.h"
#include "highgui.h"

#define PIXVAL(iplimagep, x, y) (*(uchar *)((iplimagep)->imageData + (y) * (iplimagep)->widthStep + (x)))
#define BUFSIZE 1024

int hx[BUFSIZE], hy[BUFSIZE];

int main()
{
    int i, j;

    CvCapture *capture = cvCaptureFromCAM(0);

    IplImage *frame, *buf, *img, *bin, *result;

    if (capture == NULL) {
        fprintf(stderr, "cannot capture\n");
        return 1;
    }

    frame = cvQueryFrame(capture);
    buf = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 3);  // color
    img = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1);
    bin = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1);
    result = cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 3); // color

    cvNamedWindow("input", CV_WINDOW_AUTOSIZE);
    cvNamedWindow("binary", CV_WINDOW_AUTOSIZE);
    cvNamedWindow("result", CV_WINDOW_AUTOSIZE);

    while (1) {
        frame = cvQueryFrame(capture); /* cannot be modified */

        cvFlip(frame, buf, NULL);
        cvCvtColor(buf, img, CV_BGR2GRAY);

        for (i = 0; i < img->width; i++) { hx[i] = 0; }
        for (j = 0; j < img->height; j++) { hy[j] = 0; }

        for (j = 0; j < img->height; j++) {
            for (i = 0; i < img->width; i++) {
                if (PIXVAL(img, i, j) > 128) {
                    PIXVAL(bin, i, j) = 255;
                    hx[i]++;
                    hy[j]++;
                } else {
                    PIXVAL(bin, i, j) = 0;
                }
            }
        }

        cvCvtColor(bin, result, CV_GRAY2BGR);
        for (i = 0; i < img->width; i++) {
            if (hx[i] > 0) {
                cvLine(result, cvPoint(i, img->height - 1), cvPoint(i, img->height - hx[i]/4), CV_RGB(0, 255, 0));
            }
        }
        for (j = 0; j < img->height; j++) {
            if (hy[j] > 0) {
                cvLine(result, cvPoint(img->width - 1, j), cvPoint(img->width - hy[j]/4, j), CV_RGB(0, 255, 0));
            }
        }

        cvShowImage("input", img);
        cvShowImage("binary", bin);
        cvShowImage("result", result);

        if (cvWaitKey(30) > 0) {
            break;
        }
    }
    return 0;
}
